﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace AnswerForMe.Model
{
    class SqlCommandWrapper : IAFMCommand
    {
        SqlCommand innerCommand;
        SqlConnectionWrapper wrapperConnection;

        public SqlCommandWrapper(string commandText, IAFMConnection connection)
        {
            this.Connection = connection;
            this.innerCommand = new SqlCommand(commandText, wrapperConnection.InnerConnection);
        }

        public string CommandText
        {
            get
            {
                return innerCommand.CommandText;
            }
            set
            {
                innerCommand.CommandText = value;
            }
        }

        public IAFMConnection Connection
        {
            get
            {
                return this.wrapperConnection;
            }
            set
            {
                this.wrapperConnection = value as SqlConnectionWrapper;
            }
        }

        public int ExecuteNonQuery()
        {
            return innerCommand.ExecuteNonQuery();
        }

        public DataSet ExecuteQuery()
        {
            DataSet result = new DataSet();
            SqlDataAdapter adapter = new SqlDataAdapter(innerCommand);
            adapter.Fill(result);
            return result.Tables.Count > 0 ? result : null;
        }

        public void Dispose()
        {
            innerCommand.Dispose();
        }
    }
}
