﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using AnswerForMe.Model;

namespace AnswerForMe.Presentation
{
    static class ConnectionBuilder
    {
        public static bool UserCancelConnecting = false;
        public static WCFConnection BuildConnectionFrom(IConnectionBuilderView iView)
        {
            WCFConnection connection = null;
            iView.AcceptInput();
            if (iView.IsConfirmed)
            {
                connection = new WCFConnection(iView.BaseAddress, iView.PointCode, iView.EmployeeCode, iView.EmployeePassword);
                try
                {
                    connection.Open();
                }
                catch
                {
                    connection = null;
                }
            }
            else
            {
                UserCancelConnecting = true;
            }
            return connection;
        }
    }
}