﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;

using AnswerForMe.Model;

namespace AnswerForMe.Presentation
{
    static class ConnectionManager
    {
        public static bool UserCanceledConnection = false;
        public static IAFMConnection BuildConnection(IBuildConnectionView iView)
        {
            IAFMConnection connection = null;
            iView.AcceptInput();
            if (iView.IsConfirmed)
            {
                connection = new WCFConnection(iView.BaseAddress, iView.PointCode, iView.EmployeeCode, iView.EmployeePassword);
                try
                {
                    connection.Open();
                }
                catch
                {
                    connection = null;
                }
            }
            else
            {
                UserCanceledConnection = true;
            }
            return connection;
        }

        public static IAFMConnection BuildConnection(string connectString)
        {
            return new SqlConnectionWrapper(connectString);
        }
    }
}