﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace AnswerForMe.Presentation
{
    interface ICrossThreadGuiCall
    {
        Object Invoke(Delegate del);
    }

    interface IQueryExecutorView : ICrossThreadGuiCall
    {
        DbInfo DbInfoRetrieved { set; }
        String RawQuerySqls { get; set; }
        QueryResult Result { get; set; }
        Action QueryStartedAction { get; }
        Action QuerySuccessAction { get; }
        Action QueryFailedAction { get; }

        void ReadyForInput();      
        void Close();
    }
}
