﻿using System;
using System.Data;
using System.Text;

namespace AnswerForMe.Presentation
{
    public class QueryResult
    {
        public TimeSpan ExcuteTimeCost;
        public DataSet ResultDataSet = null;
        public string[] ResultText = null;

        public void WriteTextResult()
        {
            if (ResultDataSet == null) ResultText = null;
            if (ResultDataSet.Tables.Count == 0) ResultText = null;
           
            ResultText = new string[ResultDataSet.Tables.Count];
            int i = 0;
            foreach(DataTable table in ResultDataSet.Tables)
            {
                ResultText[i++] = TextResultFor(table);
            }
        }

        private string TextResultFor(DataTable table)
        {
            StringBuilder sb = new StringBuilder();
            int c = table.Columns.Count;
            int[] lens = new int[c];
            for (int i = 0; i < c; i++)
                lens[i] = table.Columns[i].ColumnName.Length;
            int l;
            foreach (DataRow row in table.Rows)
            {
                for (int i = 0; i < c; i++)
                {
                    l = row[i].ToString().Length;
                    if (l > lens[i])
                        lens[i] = l;
                }       
            }
            for (int i = 0; i < c; i++)
            {
                DataColumn column = table.Columns[i];
                sb.Append(table.Columns[i].ColumnName.PadRight(lens[i]) + " ");
            }
            sb.AppendLine();
            for (int i = 0; i < c; i++)
            {
                sb.Append("".PadRight(lens[i], '=') + " ");
            }
            sb.AppendLine();
            foreach (DataRow row in table.Rows)
            {
                for (int i = 0; i < c; i++)
                    sb.Append(row[i].ToString().PadRight(lens[i]) + " ");
                sb.AppendLine();

            }

            return sb.ToString();
        }
    }
}
