﻿using System;
using System.IO;
using System.Text;
using System.Diagnostics;

namespace AnswerForMe.Presentation
{
    public class QueryTextFile
    {
        static int UntitledCount;

        private string untitledName;
        private string textFilePath;

        public string TextFilePath {
            get
            {
                return textFilePath;
            }
            set
            {
                textFilePath = value;
                untitledName = value == null ? "未命名" + (++UntitledCount).ToString() : null;
            }
        }
        public string FormerText { get; set; }
        public string CurrentText { get; set; }

        public string TextFileName {
            get
            {
                return IsNewFile ? untitledName : (new FileInfo(TextFilePath)).Name;
            }
        }
        public bool IsDirty { get { return FormerText != CurrentText; }}
        public bool IsNewFile { get { return untitledName != null; }}

        private QueryTextFile(string filePath = null)
        {
            TextFilePath = filePath;
            FormerText = "";
            if (filePath == null) return;
            using (StreamReader reader = new StreamReader(filePath, Encoding.Default))
            {
                CurrentText = FormerText = reader.ReadToEnd();
            }
        }

        public static QueryTextFile NewTextFile()
        {
            return new QueryTextFile();
        }

        public static QueryTextFile OpenTextFile(string filePath)
        {
            return new QueryTextFile(filePath);
        }

        public void SaveFile()
        {
            Debug.Assert(textFilePath != null);
            if (!IsDirty) return;
            using (StreamWriter writer = new StreamWriter(textFilePath, false, Encoding.Default))
            {
                writer.Write(CurrentText);
            }
            FormerText = CurrentText;
        }
    }
}
